/* To fix a bug in the Express software for the nCUBE/2 */

/*
 * $Source: /home/elephant2/parasoft/dv.nightly/paralib/stdlib/RCS/finite.c,v $
 * $Revision: 31.2 $
 *
 * Copyright ParaSoft Corporation 1991.  All rights reserved.
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 *
 * $Author: parasrc $          $Locker:  $
 * $Date: 1991/07/12 14:55:31 $
 * $Log: finite.c,v $
 * Revision 31.2  1991/07/12  14:55:31  parasrc
 * Replaced some #ifdef'd constants with functions that return the
 * proper value at runtime, by examing byte-swapping properties.
 *
 * Revision 31.1  1991/04/10  03:29:08  jwf
 * Original source code.
 *
 */

/* BEGIN_HEADER */
/*
  File: stdlib/float.c
  Author: John Salmon
  Purpose: define the values used in float.h
  References: ANSI C Standard pp.
  Defines:
  Uses:

  Copyright: ParaSoft, 1987
*/
/* END_HEADER */

#include "exptype.h"
#include "sys/expname.h"

/*
 * This file relies on 32-bit floats, 64-bit doubles
 * and a consistent "big-endian-ness" that is the same for
 * floating point and integer quantities.
 */

#define EXPON_MASK      0x7ff00000

/*
 * Return non-zero if x is finite, and 0 otherwise, i.e. x is
 * NaN or Infinity or -Infinity
 */
int finite(x)
    double x;
{
    SYSUINT *xsh = (SYSUINT *)&x;

    if(EXP_COMMON(lsb_lowest) == 0)     /* Big Endian */
        return (xsh[0] & EXPON_MASK) != EXPON_MASK;
    else
        return (xsh[1] & EXPON_MASK) != EXPON_MASK;
}

static SYSUINT _infinity_bits_be[] = {0x00000000, 0x7ff00000};
static SYSUINT _infinity_bits_le[] = {0x00000000, 0x7ff00000};
                                /* _infinity = INF */

double _infinity()
{
    if(EXP_COMMON(lsb_lowest) == 0) {   /* Big endian */
        return *(double *)_infinity_bits_be;
    }
    else {
        return *(double *)_infinity_bits_le;
    }
}
